Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1006)
@@ -4,5 +4,5 @@
 
 #include "Plane3.h"
-#include "VspBspTree.h"
+#include "VspOspTree.h"
 #include "Mesh.h"
 #include "common.h"
@@ -25,10 +25,8 @@
 //-- static members
 
-
-int VspBspTree::sFrontId = 0;
-int VspBspTree::sBackId = 0;
-int VspBspTree::sFrontAndBackId = 0;
-
-typedef pair<BspNode *, BspNodeGeometry *> bspNodePair;
+int VspOspTree::sFrontId = 0;
+int VspOspTree::sBackId = 0;
+int VspOspTree::sFrontAndBackId = 0;
+
 
 
@@ -51,86 +49,62 @@
 
 /******************************************************************************/
-/*                       class VspBspTree implementation                      */
+/*                       class VspOspTree implementation                      */
 /******************************************************************************/
 
 
-VspBspTree::VspBspTree(Environment *env):
+VspOspTree::VspOspTree():
 mRoot(NULL),
-mUseAreaForPvs(false),
-mCostNormalizer(Limits::Small),
-mViewCellsManager(NULL),
 mOutOfBoundsCell(NULL),
 mStoreRays(false),
-mRenderCostWeight(0.5),
 mUseRandomAxis(false),
 mTimeStamp(1)
 {
 	bool randomize = false;
-	env->GetBoolValue("VspBspTree.Construction.randomize", randomize);
+	Environment::GetSingleton()->GetBoolValue("VspOspTree.Construction.randomize", randomize);
 	if (randomize)
 		Randomize(); // initialise random generator for heuristics
 
 	//-- termination criteria for autopartition
-	env->GetIntValue("VspBspTree.Termination.maxDepth", mTermMaxDepth);
-	env->GetIntValue("VspBspTree.Termination.minPvs", mTermMinPvs);
-	env->GetIntValue("VspBspTree.Termination.minRays", mTermMinRays);
-	env->GetFloatValue("VspBspTree.Termination.minProbability", mTermMinProbability);
-	env->GetFloatValue("VspBspTree.Termination.maxRayContribution", mTermMaxRayContribution);
-	env->GetFloatValue("VspBspTree.Termination.minAccRayLenght", mTermMinAccRayLength);
-	env->GetFloatValue("VspBspTree.Termination.maxCostRatio", mTermMaxCostRatio);
-	env->GetIntValue("VspBspTree.Termination.missTolerance", mTermMissTolerance);
-	env->GetIntValue("VspBspTree.Termination.maxViewCells", mMaxViewCells);
+	Environment::GetSingleton()->GetIntValue("VspOspTree.Termination.maxDepth", mTermMaxDepth);
+	Environment::GetSingleton()->GetIntValue("VspOspTree.Termination.minPvs", mTermMinPvs);
+	Environment::GetSingleton()->GetIntValue("VspOspTree.Termination.minRays", mTermMinRays);
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Termination.minProbability", mTermMinProbability);
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Termination.maxRayContribution", mTermMaxRayContribution);
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Termination.maxCostRatio", mTermMaxCostRatio);
+	Environment::GetSingleton()->GetIntValue("VspOspTree.Termination.missTolerance", mTermMissTolerance);
+	Environment::GetSingleton()->GetIntValue("VspOspTree.Termination.maxViewCells", mMaxViewCells);
 
 	//-- max cost ratio for early tree termination
-	env->GetFloatValue("VspBspTree.Termination.maxCostRatio", mTermMaxCostRatio);
-
-	env->GetFloatValue("VspBspTree.Termination.minGlobalCostRatio", mTermMinGlobalCostRatio);
-	env->GetIntValue("VspBspTree.Termination.globalCostMissTolerance", mTermGlobalCostMissTolerance);
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Termination.maxCostRatio", mTermMaxCostRatio);
+
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Termination.minGlobalCostRatio", mTermMinGlobalCostRatio);
+	Environment::GetSingleton()->GetIntValue("VspOspTree.Termination.globalCostMissTolerance", mTermGlobalCostMissTolerance);
 
 	// HACK//mTermMinPolygons = 25;
 
 	//-- factors for bsp tree split plane heuristics
-	env->GetFloatValue("VspBspTree.Factor.pvs", mPvsFactor);
-	env->GetFloatValue("VspBspTree.Termination.ct_div_ci", mCtDivCi);
-
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Termination.ct_div_ci", mCtDivCi);
 
 	//-- partition criteria
-	env->GetIntValue("VspBspTree.maxPolyCandidates", mMaxPolyCandidates);
-	env->GetIntValue("VspBspTree.maxRayCandidates", mMaxRayCandidates);
-	env->GetIntValue("VspBspTree.splitPlaneStrategy", mSplitPlaneStrategy);
-
-	env->GetFloatValue("VspBspTree.Construction.epsilon", mEpsilon);
-	env->GetIntValue("VspBspTree.maxTests", mMaxTests);
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Construction.epsilon", mEpsilon);
 
 	// if only the driving axis is used for axis aligned split
-	env->GetBoolValue("VspBspTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
-	
-	//-- termination criteria for axis aligned split
-	env->GetFloatValue("VspBspTree.Termination.AxisAligned.maxRayContribution", 
-								mTermMaxRayContriForAxisAligned);
-	env->GetIntValue("VspBspTree.Termination.AxisAligned.minRays",
-							 mTermMinRaysForAxisAligned);
-
-	//env->GetFloatValue("VspBspTree.maxTotalMemory", mMaxTotalMemory);
-	env->GetFloatValue("VspBspTree.maxStaticMemory", mMaxMemory);
-
-	env->GetFloatValue("VspBspTree.Construction.renderCostWeight", mRenderCostWeight);
-	env->GetBoolValue("VspBspTree.usePolygonSplitIfAvailable", mUsePolygonSplitIfAvailable);
-
-	env->GetBoolValue("VspBspTree.useCostHeuristics", mUseCostHeuristics);
-	env->GetBoolValue("VspBspTree.useSplitCostQueue", mUseSplitCostQueue);
-	env->GetBoolValue("VspBspTree.simulateOctree", mCirculatingAxis);
-	env->GetBoolValue("VspBspTree.useRandomAxis", mUseRandomAxis);
-	env->GetIntValue("VspBspTree.nodePriorityQueueType", mNodePriorityQueueType);
-
-	env->GetBoolValue("ViewCells.PostProcess.emptyViewCellsMerge", mEmptyViewCellsMergeAllowed);
+	Environment::GetSingleton()->GetBoolValue("VspOspTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
+	
+	//Environment::GetSingleton()->GetFloatValue("VspOspTree.maxTotalMemory", mMaxTotalMemory);
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.maxStaticMemory", mMaxMemory);
+
+	Environment::GetSingleton()->GetBoolValue("VspOspTree.useCostHeuristics", mUseCostHeuristics);
+	Environment::GetSingleton()->GetBoolValue("VspOspTree.simulateOctree", mCirculatingAxis);
+	Environment::GetSingleton()->GetBoolValue("VspOspTree.useRandomAxis", mUseRandomAxis);
+	Environment::GetSingleton()->GetIntValue("VspOspTree.nodePriorityQueueType", mNodePriorityQueueType);
 	
 	char subdivisionStatsLog[100];
-	env->GetStringValue("VspBspTree.subdivisionStats", subdivisionStatsLog);
+	Environment::GetSingleton()->GetStringValue("VspOspTree.subdivisionStats", subdivisionStatsLog);
 	mSubdivisionStats.open(subdivisionStatsLog);
 
-	env->GetFloatValue("VspBspTree.Construction.minBand", mMinBand);
-	env->GetFloatValue("VspBspTree.Construction.maxBand", mMaxBand);
-	env->GetBoolValue("VspBspTree.Construction.useDrivingAxisForMaxCost", mUseDrivingAxisForMaxCost);
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Construction.minBand", mMinBand);
+	Environment::GetSingleton()->GetFloatValue("VspOspTree.Construction.maxBand", mMaxBand);
+	
 
 	//-- debug output
@@ -145,52 +119,18 @@
 	Debug << "miss tolerance: " << mTermMissTolerance << endl;
 	Debug << "max view cells: " << mMaxViewCells << endl;
-	Debug << "max polygon candidates: " << mMaxPolyCandidates << endl;
-	//Debug << "max plane candidates: " << mMaxRayCandidates << endl;
 	Debug << "randomize: " << randomize << endl;
 
-	Debug << "using area for pvs: " << mUseAreaForPvs << endl;
-	Debug << "render cost weight: " << mRenderCostWeight << endl;
 	Debug << "min global cost ratio: " << mTermMinGlobalCostRatio << endl;
 	Debug << "global cost miss tolerance: " << mTermGlobalCostMissTolerance << endl;
 	Debug << "only driving axis: " << mOnlyDrivingAxis << endl;
 	Debug << "max memory: " << mMaxMemory << endl;
-	Debug << "use poly split if available: " << mUsePolygonSplitIfAvailable << endl;
 	Debug << "use cost heuristics: " << mUseCostHeuristics << endl;
-	Debug << "use split cost queue: " << mUseSplitCostQueue << endl;
 	Debug << "subdivision stats log: " << subdivisionStatsLog << endl;
 	Debug << "use random axis: " << mUseRandomAxis << endl;
 	Debug << "priority queue type: " << mNodePriorityQueueType << endl;
-	Debug << "empty view cells merge: " << mEmptyViewCellsMergeAllowed << endl;
 	Debug << "circulating axis: " << mCirculatingAxis << endl;
 	Debug << "minband: " << mMinBand << endl;
 	Debug << "maxband: " << mMaxBand << endl;
-	Debug << "use driving axis for max cost: " << mUseDrivingAxisForMaxCost << endl;
-
-	Debug << "Split plane strategy: ";
-
-	if (mSplitPlaneStrategy & RANDOM_POLYGON)
-	{
-		Debug << "random polygon ";
-	}
-	if (mSplitPlaneStrategy & AXIS_ALIGNED)
-	{
-		Debug << "axis aligned ";
-	}
-	if (mSplitPlaneStrategy & LEAST_RAY_SPLITS)
-	{
-		mCostNormalizer += mLeastRaySplitsFactor;
-		Debug << "least ray splits ";
-	}
-	if (mSplitPlaneStrategy & BALANCED_RAYS)
-	{
-		mCostNormalizer += mBalancedRaysFactor;
-		Debug << "balanced rays ";
-	}
-	if (mSplitPlaneStrategy & PVS)
-	{
-		mCostNormalizer += mPvsFactor;
-		Debug << "pvs";
-	}
-
+	
 
 	mSplitCandidates = new vector<SortableEntry>;
@@ -199,19 +139,6 @@
 }
 
-VspBspTree::VspBspTree():
-mRoot(NULL),
-mUseAreaForPvs(false),
-mCostNormalizer(Limits::Small),
-mViewCellsManager(NULL),
-mOutOfBoundsCell(NULL),
-mStoreRays(false),
-mRenderCostWeight(0.5),
-mUseRandomAxis(false),
-mTimeStamp(1),
-mEpsilon(1e-6f)
-{
-}
-
-BspViewCell *VspBspTree::GetOutOfBoundsCell()
+
+BspViewCell *VspOspTree::GetOutOfBoundsCell()
 {
 	return mOutOfBoundsCell;
@@ -219,5 +146,5 @@
 
 
-BspViewCell *VspBspTree::GetOrCreateOutOfBoundsCell()
+BspViewCell *VspOspTree::GetOrCreateOutOfBoundsCell()
 {
 	if (!mOutOfBoundsCell)
@@ -232,5 +159,5 @@
 
 
-const BspTreeStatistics &VspBspTree::GetStatistics() const
+const BspTreeStatistics &VspOspTree::GetStatistics() const
 {
 	return mBspStats;
@@ -238,5 +165,5 @@
 
 
-VspBspTree::~VspBspTree()
+VspOspTree::~VspOspTree()
 {
 	DEL_PTR(mRoot);
@@ -244,110 +171,5 @@
 }
 
-
-int VspBspTree::AddMeshToPolygons(Mesh *mesh,
-								  PolygonContainer &polys,
-								  MeshInstance *parent)
-{
-	FaceContainer::const_iterator fi;
-
-	// copy the face data to polygons
-	for (fi = mesh->mFaces.begin(); fi != mesh->mFaces.end(); ++ fi)
-	{
-		Polygon3 *poly = new Polygon3((*fi), mesh);
-
-		if (poly->Valid(mEpsilon))
-		{
-			poly->mParent = parent; // set parent intersectable
-			polys.push_back(poly);
-		}
-		else
-			DEL_PTR(poly);
-	}
-	return (int)mesh->mFaces.size();
-}
-
-
-int VspBspTree::AddToPolygonSoup(const ViewCellContainer &viewCells,
-								 PolygonContainer &polys,
-								 int maxObjects)
-{
-	int limit = (maxObjects > 0) ?
-		Min((int)viewCells.size(), maxObjects) : (int)viewCells.size();
-
-	int polysSize = 0;
-
-	for (int i = 0; i < limit; ++ i)
-	{
-		if (viewCells[i]->GetMesh()) // copy the mesh data to polygons
-		{
-			mBox.Include(viewCells[i]->GetBox()); // add to BSP tree aabb
-			polysSize +=
-				AddMeshToPolygons(viewCells[i]->GetMesh(),
-								  polys,
-								  viewCells[i]);
-		}
-	}
-
-	return polysSize;
-}
-
-
-int VspBspTree::AddToPolygonSoup(const ObjectContainer &objects,
-								 PolygonContainer &polys,
-								 int maxObjects)
-{
-	int limit = (maxObjects > 0) ?
-		Min((int)objects.size(), maxObjects) : (int)objects.size();
-
-	for (int i = 0; i < limit; ++i)
-	{
-		Intersectable *object = objects[i];//*it;
-		Mesh *mesh = NULL;
-
-		switch (object->Type()) // extract the meshes
-		{
-		case Intersectable::MESH_INSTANCE:
-			mesh = dynamic_cast<MeshInstance *>(object)->GetMesh();
-			break;
-		case Intersectable::VIEW_CELL:
-			mesh = dynamic_cast<ViewCell *>(object)->GetMesh();
-			break;
-		case Intersectable::TRANSFORMED_MESH_INSTANCE:
-			{
-				TransformedMeshInstance *mi = dynamic_cast<TransformedMeshInstance *>(object);
-
-				if (!mi->GetMesh())
-					break;
-
-				mesh = new Mesh(*mi->GetMesh());
-
-				Matrix4x4 m;
-				mi->GetWorldTransform(m);
-
-				mesh->ApplyTransformation(m);
-
-                break;
-			}
-		default:
-			Debug << "intersectable type not supported" << endl;
-			break;
-		}
-
-        if (mesh) // copy the mesh data to polygons
-		{
-			mBox.Include(object->GetBox()); // add to BSP tree aabb
-			AddMeshToPolygons(mesh, polys, NULL);
-
-			// cleanup
-			if (object->Type() == Intersectable::TRANSFORMED_MESH_INSTANCE)
-				DEL_PTR(mesh);
-		}
-	}
-
-	return (int)polys.size();
-}
-
-
-void VspBspTree::Construct(const VssRayContainer &sampleRays,
+void VspOspTree::Construct(const VssRayContainer &sampleRays,
 						   AxisAlignedBox3 *forcedBoundingBox)
 {
@@ -371,41 +193,4 @@
 	int numObj = 0;
 
-	//-- extract polygons intersected by the rays
-	for (rit = sampleRays.begin(); rit != rit_end; ++ rit)
-	{
-		VssRay *ray = *rit;
-
-		if ((mBox.IsInside(ray->mTermination) || !forcedBoundingBox) &&
-			ray->mTerminationObject && 
-			!ray->mTerminationObject->Mailed())
-		{
-			ray->mTerminationObject->Mail();
-			MeshInstance *obj = dynamic_cast<MeshInstance *>(ray->mTerminationObject);
-			AddMeshToPolygons(obj->GetMesh(), polys, obj);
-			++ numObj;
-
-			//-- compute bounding box
-			if (!forcedBoundingBox)
-				mBox.Include(ray->mTermination);
-		}
-
-		if ((mBox.IsInside(ray->mOrigin) || !forcedBoundingBox) &&
-			ray->mOriginObject && 
-			!ray->mOriginObject->Mailed())
-		{
-			ray->mOriginObject->Mail();
-			MeshInstance *obj = dynamic_cast<MeshInstance *>(ray->mOriginObject);
-			AddMeshToPolygons(obj->GetMesh(), polys, obj);
-			++ numObj;
-
-			//-- compute bounding box
-			if (!forcedBoundingBox)
-				mBox.Include(ray->mOrigin);
-		}
-	}
-	
-	Debug << "maximal pvs (i.e., pvs still considered as valid) : " 
-		  << mViewCellsManager->GetMaxPvsSize() << endl;
-
 	//-- store rays
 	for (rit = sampleRays.begin(); rit != rit_end; ++ rit)
@@ -430,42 +215,20 @@
 	}
 
-	// normalize
-	if (mUseAreaForPvs)
-		mTermMinProbability *= mBox.SurfaceArea(); 
-	else 
-		mTermMinProbability *= mBox.GetVolume();
-
-	// throw out unnecessary polygons
-	PreprocessPolygons(polys);
-
-	mBspStats.polys = (int)polys.size();
+	mTermMinProbability *= mBox.GetVolume();
+
 	mGlobalCostMisses = 0;
 
 	cout << "finished" << endl;
 
-	Debug << "\nPolygon extraction: " << (int)polys.size() << " polys extracted from "
-		  << (int)sampleRays.size() << " rays in "
-		  << TimeDiff(startTime, GetTime())*1e-3 << " secs" << endl << endl;
-
 	// use split cost priority queue
-	if (mUseSplitCostQueue)
-	{
-		ConstructWithSplitQueue(polys, rays);
-	}
-	else
-	{
-		Construct(polys, rays);
-	}
-
-	// clean up polygons
-	CLEAR_CONTAINER(polys);
+	Construct(rays);
 }
 
 
 // TODO: return memory usage in MB
-float VspBspTree::GetMemUsage() const
+float VspOspTree::GetMemUsage() const
 {
 	return (float)
-		 (sizeof(VspBspTree) + 
+		 (sizeof(VspOspTree) + 
 		  mBspStats.Leaves() * sizeof(BspLeaf) + 
 		  mCreatedViewCells * sizeof(BspViewCell) +
@@ -476,137 +239,22 @@
 
 
-
-void VspBspTree::Construct(const PolygonContainer &polys, RayInfoContainer *rays)
-{
-	VspBspTraversalQueue tQueue;
+void VspOspTree::Construct(RayInfoContainer *rays)
+{
+	VspOspSplitQueue tQueue;
 
 	mRoot = new BspLeaf();
 
-	// constrruct root node geometry
-	BspNodeGeometry *geom = new BspNodeGeometry();
-	ConstructGeometry(mRoot, *geom);
-
-	const float prop = mUseAreaForPvs ? geom->GetArea() : geom->GetVolume();
-
-	VspBspTraversalData tData(mRoot,
-							  new PolygonContainer(polys),
+	const float prop = mBox.GetVolume();
+
+	VspOspTraversalData tData(mRoot,
 							  0,
 							  rays,
                               ComputePvsSize(*rays),
 							  prop,
-							  geom);
-
-	EvalPriority(tData);
-
-
-	// first node is kd node, i.e. an axis aligned box
-	if (1)
-        tData.mIsKdNode = true;
-	else
-		tData.mIsKdNode = false;
-
-	tQueue.push(tData);
-
-
-	mTotalCost = tData.mPvs * tData.mProbability / mBox.GetVolume();
-	mTotalPvsSize = tData.mPvs;
-	
-	mSubdivisionStats 
-			<< "#ViewCells\n1" <<  endl
-			<< "#RenderCostDecrease\n0" << endl 
-			<< "#TotalRenderCost\n" << mTotalCost << endl
-			<< "#AvgRenderCost\n" << mTotalPvsSize << endl;
-
-	Debug << "total cost: " << mTotalCost << endl;
-	
-	
-	mBspStats.Start();
-	cout << "Constructing vsp bsp tree ... \n";
-
-	long startTime = GetTime();	
-	int nLeaves = 500;
-	int nViewCells = 500;
-
-	// used for intermediate time measurements and progress
-	long interTime = GetTime();	
-
-	mOutOfMemory = false;
-
-	mCreatedViewCells = 0;
-	
-	while (!tQueue.empty())
-	{
-		tData = tQueue.top();
-	    tQueue.pop();		
-
-		if (0 && !mOutOfMemory)
-		{
-			float mem = GetMemUsage();
-
-			if (mem > mMaxMemory)
-			{
-				mOutOfMemory = true;
-				Debug << "memory limit reached: " << mem << endl;
-			}
-		}
-
-		// subdivide leaf node
-		BspNode *r = Subdivide(tQueue, tData);
-
-		if (r == mRoot)
-			Debug << "VSP BSP tree construction time spent at root: "
-				  << TimeDiff(startTime, GetTime())*1e-3 << "s" << endl;
-
-		if (mBspStats.Leaves() >= nLeaves)
-		{
-			nLeaves += 500;
-
-			cout << "leaves=" << mBspStats.Leaves() << endl;
-			Debug << "needed "
-				  << TimeDiff(interTime, GetTime())*1e-3 
-				  << " secs to create 500 view cells" << endl;
-			interTime = GetTime();
-		}
-
-		if (mCreatedViewCells >= nViewCells)
-		{
-			nViewCells += 500;
-
-			cout << "generated " << mCreatedViewCells << " viewcells" << endl;
-		}
-	}
-
-	Debug << "Used Memory: " << GetMemUsage() << " MB" << endl << endl;
-	cout << "finished\n";
-
-	mBspStats.Stop();
-}
-
-
-
-void VspBspTree::ConstructWithSplitQueue(const PolygonContainer &polys, 
-											  RayInfoContainer *rays)
-{
-	VspBspSplitQueue tQueue;
-
-	mRoot = new BspLeaf();
-
-	// constrruct root node geometry
-	BspNodeGeometry *geom = new BspNodeGeometry();
-	ConstructGeometry(mRoot, *geom);
-
-	const float prop = mUseAreaForPvs ? geom->GetArea() : geom->GetVolume();
-
-	VspBspTraversalData tData(mRoot,
-							  new PolygonContainer(polys),
-							  0,
-							  rays,
-                              ComputePvsSize(*rays),
-							  prop,
-							  geom);
+							  mBox);
 
 
 	// compute first split candidate
-	VspBspSplitCandidate splitCandidate;
+	VspOspSplitCandidate splitCandidate;
 	EvalSplitCandidate(tData, splitCandidate);
 
@@ -697,5 +345,5 @@
 
 
-bool VspBspTree::LocalTerminationCriteriaMet(const VspBspTraversalData &data) const
+bool VspOspTree::LocalTerminationCriteriaMet(const VspOspTraversalData &data) const
 {
 	return
@@ -708,5 +356,5 @@
 
 
-bool VspBspTree::GlobalTerminationCriteriaMet(const VspBspTraversalData &data) const
+bool VspOspTree::GlobalTerminationCriteriaMet(const VspOspTraversalData &data) const
 {
 	return
@@ -718,152 +366,9 @@
 
 
-
-BspNode *VspBspTree::Subdivide(VspBspTraversalQueue &tQueue,
-							   VspBspTraversalData &tData)
-{
-	BspNode *newNode = tData.mNode;
-
-	if (!LocalTerminationCriteriaMet(tData) && !GlobalTerminationCriteriaMet(tData))
-	{
-		PolygonContainer coincident;
-
-		VspBspTraversalData tFrontData;
-		VspBspTraversalData tBackData;
-
-		// create new interior node and two leaf nodes
-		// or return leaf as it is (if maxCostRatio missed)
-		int splitAxis;
-		bool splitFurther = true;
-		int maxCostMisses = tData.mMaxCostMisses;
-		
-		Plane3 splitPlane;
-		BspLeaf *leaf = dynamic_cast<BspLeaf *>(tData.mNode);
-		
-		// choose next split plane
-		if (!SelectPlane(splitPlane, leaf, tData, tFrontData, tBackData, splitAxis))
-		{
-			++ maxCostMisses;
-
-			if (maxCostMisses > mTermMissTolerance)
-			{
-				// terminate branch because of max cost
-				++ mBspStats.maxCostNodes;
-				splitFurther = false;
-			}
-		}
-	
-		// if this a valid split => subdivide this node further
-		if (splitFurther) //-- continue subdivision
-		{
-			newNode = SubdivideNode(splitPlane, tData, tFrontData, tBackData, coincident);
-
-			if (splitAxis < 3)
-				++ mBspStats.splits[splitAxis];
-			else
-				++ mBspStats.polySplits;
-
-			// if it was a kd node (i.e., a box) and the split axis is axis aligned, it is still a kd node
-			tFrontData.mIsKdNode = tBackData.mIsKdNode = (tData.mIsKdNode && (splitAxis < 3));
-			tFrontData.mAxis = tBackData.mAxis = splitAxis;
-
-			// how often was max cost ratio missed in this branch?
-			tFrontData.mMaxCostMisses = maxCostMisses;
-			tBackData.mMaxCostMisses = maxCostMisses;
-
-			EvalPriority(tFrontData);
-			EvalPriority(tBackData);
-
-			// evaluate subdivision stats
-			if (1)
-			{
-				float cFront = (float)tFrontData.mPvs * tFrontData.mProbability;
-				float cBack = (float)tBackData.mPvs * tBackData.mProbability;
-				float cData = (float)tData.mPvs * tData.mProbability;;
-
-                float costDecr = (cFront + cBack - cData) / mBox.GetVolume();
-
-				mTotalCost += costDecr;
-				mTotalPvsSize += tFrontData.mPvs + tBackData.mPvs - tData.mPvs;
-
-				mSubdivisionStats 
-						<< "#ViewCells\n" << mBspStats.Leaves() << endl
-						<< "#RenderCostDecrease\n" << -costDecr << endl 
-						<< "#TotalRenderCost\n" << mTotalCost << endl
-						<< "#AvgRenderCost\n" << (float)mTotalPvsSize / (float)mBspStats.Leaves() << endl;
-			}
-
-			// push the children on the stack
-			tQueue.push(tFrontData);
-			tQueue.push(tBackData);
-
-			// delete old leaf node
-			DEL_PTR(tData.mNode);
-		}
-	}
-
-	//-- terminate traversal and create new view cell
-	if (newNode->IsLeaf())
-	{
-		BspLeaf *leaf = dynamic_cast<BspLeaf *>(newNode);
-		BspViewCell *viewCell = new BspViewCell();
-		
-		leaf->SetViewCell(viewCell);
-	
-		//-- update pvs
-		int conSamp = 0;
-		float sampCon = 0.0f;
-		AddToPvs(leaf, *tData.mRays, sampCon, conSamp);
-
-		// update scalar pvs size lookup
-		mViewCellsManager->SetScalarPvsSize(viewCell, viewCell->GetPvs().GetSize());
-	
-
-		mBspStats.contributingSamples += conSamp;
-		mBspStats.sampleContributions +=(int) sampCon;
-
-		//-- store additional info
-		if (mStoreRays)
-		{
-			RayInfoContainer::const_iterator it, it_end = tData.mRays->end();
-			for (it = tData.mRays->begin(); it != it_end; ++ it)
-			{
-				(*it).mRay->Ref();			
-				leaf->mVssRays.push_back((*it).mRay);
-			}
-		}
-
-		// should I check here?
-		if (0 && !mViewCellsManager->CheckValidity(viewCell, 0, mViewCellsManager->GetMaxPvsSize()))
-		{
-			viewCell->SetValid(false);
-			leaf->SetTreeValid(false);
-			PropagateUpValidity(leaf);
-
-			++ mBspStats.invalidLeaves;
-		}
-		
-        viewCell->mLeaf = leaf;
-
-		if (mUseAreaForPvs)
-			viewCell->SetArea(tData.mProbability);
-		else
-			viewCell->SetVolume(tData.mProbability);
-
-		leaf->mProbability = tData.mProbability;
-
-		EvaluateLeafStats(tData);		
-	}
-
-	//-- cleanup
-	tData.Clear();
-
-	return newNode;
-}
-
 // subdivide using a split plane queue
-BspNode *VspBspTree::Subdivide(VspBspSplitQueue &tQueue,
-							   VspBspSplitCandidate &splitCandidate)
-{
-	VspBspTraversalData &tData = splitCandidate.mParentData;
+BspNode *VspOspTree::Subdivide(VspOspSplitQueue &tQueue,
+							   VspOspSplitCandidate &splitCandidate)
+{
+	VspOspTraversalData &tData = splitCandidate.mParentData;
 
 	BspNode *newNode = tData.mNode;
@@ -871,26 +376,17 @@
 	if (!LocalTerminationCriteriaMet(tData) && !GlobalTerminationCriteriaMet(tData))
 	{	
-		PolygonContainer coincident;
-
-		VspBspTraversalData tFrontData;
-		VspBspTraversalData tBackData;
+		VspOspTraversalData tFrontData;
+		VspOspTraversalData tBackData;
 
 		//-- continue subdivision
 		
 		// create new interior node and two leaf node
-		const Plane3 splitPlane = splitCandidate.mSplitPlane;
+		//TODO
+		const Plane3 splitPlane;// = splitCandidate.mSplitPlane;
 				
-		newNode = SubdivideNode(splitPlane, tData, tFrontData, tBackData, coincident);
-	
-		const int splitAxis = splitCandidate.mSplitAxis;
+		newNode = SubdivideNode(splitPlane, tData, tFrontData, tBackData);
+	
 		const int maxCostMisses = splitCandidate.mMaxCostMisses;
 
-		if (splitAxis < 3)
-			++ mBspStats.splits[splitAxis];
-		else
-			++ mBspStats.polySplits;
-
-		tFrontData.mIsKdNode = tBackData.mIsKdNode = (tData.mIsKdNode && (splitAxis < 3));
-		tFrontData.mAxis = tBackData.mAxis = splitAxis;
 
 		// how often was max cost ratio missed in this branch?
@@ -922,6 +418,6 @@
 	
 		//-- push the new split candidates on the stack
-		VspBspSplitCandidate frontCandidate;
-		VspBspSplitCandidate backCandidate;
+		VspOspSplitCandidate frontCandidate;
+		VspOspSplitCandidate backCandidate;
 
 		EvalSplitCandidate(tFrontData, frontCandidate);
@@ -969,9 +465,5 @@
 		viewCell->mLeaf = leaf;
 
-		if (mUseAreaForPvs)
-			viewCell->SetArea(tData.mProbability);
-		else
-			viewCell->SetVolume(tData.mProbability);
-
+		viewCell->SetVolume(tData.mProbability);
         leaf->mProbability = tData.mProbability;
 
@@ -986,40 +478,19 @@
 
 
-void VspBspTree::EvalPriority(VspBspTraversalData &tData) const
-{
-    switch (mNodePriorityQueueType) 
-	{
-	case BREATH_FIRST:
-		tData.mPriority = (float)-tData.mDepth;
-		break;
-	case DEPTH_FIRST:
-		tData.mPriority = (float)tData.mDepth;
-		break;
-	default:
-		tData.mPriority = tData.mPvs * tData.mProbability;
-		//Debug << "priority: " << tData.mPriority << endl;
-		break;
-	}
-}
-
-
-void VspBspTree::EvalSplitCandidate(VspBspTraversalData &tData,
-									VspBspSplitCandidate &splitData)
-{
-	VspBspTraversalData frontData;
-	VspBspTraversalData backData;
+void VspOspTree::EvalSplitCandidate(VspOspTraversalData &tData,
+									VspOspSplitCandidate &splitData)
+{
+	VspOspTraversalData frontData;
+	VspOspTraversalData backData;
 
 	BspLeaf *leaf = dynamic_cast<BspLeaf *>(tData.mNode);
 
 	// compute locally best split plane
-    bool success = SelectPlane(splitData.mSplitPlane, leaf, tData, 
-							   frontData, backData, splitData.mSplitAxis);
-
-	// TODO: reuse
-	DEL_PTR(frontData.mGeometry);
-	DEL_PTR(backData.mGeometry);
-	
+	// TODO
+    const bool success =0;/// SelectPlane(splitData.mSplitPlane, tData, 
+//									 frontData, backData);
+	//TODO
 	// compute global decrease in render cost
-	splitData.mRenderCost = EvalRenderCostDecrease(splitData.mSplitPlane, tData);
+	splitData.mRenderCost = 0;//EvalRenderCostDecrease(splitData.mSplitPlane, tData);
 	splitData.mParentData = tData;
 	splitData.mMaxCostMisses = success ? tData.mMaxCostMisses : tData.mMaxCostMisses + 1;
@@ -1027,9 +498,8 @@
 
 
-BspInterior *VspBspTree::SubdivideNode(const Plane3 &splitPlane,
-									   VspBspTraversalData &tData,
-									   VspBspTraversalData &frontData,
-									   VspBspTraversalData &backData,
-									   PolygonContainer &coincident)
+BspInterior *VspOspTree::SubdivideNode(const Plane3 &splitPlane,
+									   VspOspTraversalData &tData,
+									   VspOspTraversalData &frontData,
+									   VspOspTraversalData &backData)
 {
 	BspLeaf *leaf = dynamic_cast<BspLeaf *>(tData.mNode);
@@ -1037,9 +507,7 @@
 	//-- the front and back traversal data is filled with the new values
 	frontData.mDepth = tData.mDepth + 1;
-	frontData.mPolygons = new PolygonContainer();
 	frontData.mRays = new RayInfoContainer();
 	
 	backData.mDepth = tData.mDepth + 1;
-	backData.mPolygons = new PolygonContainer();
 	backData.mRays = new RayInfoContainer();
 	
@@ -1059,52 +527,17 @@
 	
 	// if geometry was not already computed
-	if (!frontData.mGeometry && !backData.mGeometry)
-	{
-		frontData.mGeometry = new BspNodeGeometry();
-		backData.mGeometry = new BspNodeGeometry();
-
-		tData.mGeometry->SplitGeometry(*frontData.mGeometry,
-									   *backData.mGeometry,
-									   splitPlane,
-									   mBox,
-									   //0.0f);
-									   mEpsilon);
-		
-		if (mUseAreaForPvs)
-		{
-			frontData.mProbability = frontData.mGeometry->GetArea();
-			backData.mProbability = backData.mGeometry->GetArea();
-		}
-		else
-		{
-			frontData.mProbability = frontData.mGeometry->GetVolume();
-			backData.mProbability = tData.mProbability - frontData.mProbability;
-
-			// should never come here: wrong volume !!!
-			if (0)
-			{
-				if (frontData.mProbability < -0.00001)
-					Debug << "fatal error f: " << frontData.mProbability << endl;
-				if (backData.mProbability < -0.00001)
-					Debug << "fatal error b: " << backData.mProbability << endl;
-
-				// clamp because of precision issues
-				if (frontData.mProbability < 0)	frontData.mProbability = 0;
-				if (backData.mProbability < 0) backData.mProbability = 0;
-			}
-		}
-	}
-
-	
-    // subdivide polygons
-	SplitPolygons(splitPlane,
-				  *tData.mPolygons,
-	              *frontData.mPolygons,
-				  *backData.mPolygons,
-				  coincident);
-
-
-
-	///////////////////////////////////////
+	// TODO
+
+#if TODO
+	tData.mBoundingBox.Split(splitPlane.mAxis, splitPlane.mPosition, 
+							 frontData.mBoundingBox, backData.mBoundingBox);
+
+#endif
+
+	frontData.mProbability = frontData.mBoundingBox.GetVolume();
+	backData.mProbability = tData.mProbability - frontData.mProbability;
+
+	
+    ///////////////////////////////////////////
 	// subdivide further
 
@@ -1149,11 +582,9 @@
 	interior->mTimeStamp = mTimeStamp ++;
 	
-
-	//DEL_PTR(leaf);
 	return interior;
 }
 
 
-void VspBspTree::AddToPvs(BspLeaf *leaf,
+void VspOspTree::AddToPvs(BspLeaf *leaf,
 						  const RayInfoContainer &rays,
 						  float &sampleContributions,
@@ -1200,5 +631,5 @@
 
 
-void VspBspTree::SortSplitCandidates(const RayInfoContainer &rays, 
+void VspOspTree::SortSplitCandidates(const RayInfoContainer &rays, 
 									 const int axis, 
 									 float minBand, 
@@ -1251,5 +682,5 @@
 
 
-float VspBspTree::BestCostRatioHeuristics(const RayInfoContainer &rays,
+float VspOspTree::BestCostRatioHeuristics(const RayInfoContainer &rays,
 										  const AxisAlignedBox3 &box,
 										  const int pvsSize,
@@ -1413,5 +844,5 @@
 	if (splitPlaneFound)
 	{
-		ratio = mPvsFactor * newRenderCost / (oldRenderCost + Limits::Small);
+		ratio = newRenderCost / (oldRenderCost + Limits::Small);
 	}
 	//if (axis != 1)
@@ -1423,12 +854,8 @@
 
 
-float VspBspTree::SelectAxisAlignedPlane(Plane3 &plane,
-										 const VspBspTraversalData &tData,
-										 int &axis,
-										 BspNodeGeometry **frontGeom,
-										 BspNodeGeometry **backGeom,
-										 float &pFront,
-										 float &pBack,
-										 const bool isKdNode)
+float VspOspTree::SelectPlane(const VspOspTraversalData &tData,
+							  AxisAlignedPlane &plane,
+							  float &pFront,
+							  float &pBack)
 {
 	float nPosition[3];
@@ -1437,42 +864,9 @@
 	float nProbBack[3];
 
-	BspNodeGeometry *nFrontGeom[3];
-	BspNodeGeometry *nBackGeom[3];
-
-	// set to NULL, so I can find out which gemetry was stored
-	for (int i = 0; i < 3; ++ i)
-	{
-		nFrontGeom[i] = NULL;
-		nBackGeom[i] = NULL;
-	}
-
 	// create bounding box of node geometry
-	AxisAlignedBox3 box;
-		
-	//TODO: for kd split geometry already is box => only take minmax vertices
-	if (1)
-	{
-		// get bounding box from geometry
-		tData.mGeometry->GetBoundingBox(box);
-	}
-	else
-	{
-		box.Initialize();
-		RayInfoContainer::const_iterator ri, ri_end = tData.mRays->end();
-
-		for(ri = tData.mRays->begin(); ri < ri_end; ++ ri)
-			box.Include((*ri).ExtrapTermination());
-	}
-
+	AxisAlignedBox3 box = tData.mBoundingBox;
+		
 	int sAxis = 0;
-	int bestAxis;
-
-	// if max cost ratio is exceeded, take split along longest axis instead
-	const float maxCostRatioForArbitraryAxis = 0.9f;
-
-	if (mUseDrivingAxisForMaxCost)
-		bestAxis = box.Size().DrivingAxis();
-	else
-		bestAxis = -1;
+	int bestAxis = -1;
 
 #if 0
@@ -1493,9 +887,6 @@
 		sAxis = box.Size().DrivingAxis();
 
-		
-	//Debug << "use special axis: " << useSpecialAxis << endl;
-	//Debug << "axis: " << sAxis << " drivingaxis: " << box.Size().DrivingAxis();
-
-	for (axis = 0; axis < 3 ; ++ axis)
+
+	for (int axis = 0; axis < 3 ; ++ axis)
 	{
 		if (!useSpecialAxis || (axis == sAxis))
